use crate::{Margin, Slide};
use eframe::egui::{Context, Frame, Ui};
use eframe::{egui, epi};

#[derive(Default)]
pub struct Introduction {
    strengths: bool,
}

impl Slide for Introduction {
    fn transition(&mut self, ctx: &Context) -> bool {
        let done = self.strengths;
        self.strengths = true;
        done
    }

    fn show(&mut self, ui: &mut Ui, _ctx: &Context) {
        Frame::none().margin(Margin::same(20.0)).show(ui, |ui| {
            ui.heading("Introduction to Artistic Algorithms");
            ui.add_space(8.0);
            ui.label("Weaknesses");
            ui.small(" ✖ Social context");
            ui.small(" ✖ Human emotion");
            ui.small(" ✖ Political commentary");
            if self.strengths {
                ui.add_space(10.0);
                ui.label("Strengths");
                ui.small(" ✔ Following rules");
                ui.small(" ✔ Performing computation");
                ui.small(" ✔ Harnessing chaos and randomness");
                ui.small(" ✔ Guided exploration");
            }
        });
    }
}
